Attribute VB_Name = "modFillet"
Option Explicit

Private MyModel3D As IModel_DG
Private MyObjGen3D As IObjectGenerator_DG
Private MyView3D As IView_DG
Private MyDraw3D As IDraw_DG

Public Sub InitKernelCAD(ByRef frmParent As Form)
    ' high-level object creation
    Set MyModel3D = frmParent.MyKernelCAD.GetModel()
    Set MyView3D = frmParent.MyKernelCAD.GetView()
    Set MyObjGen3D = MyModel3D
    Set MyDraw3D = MyModel3D
    
    Call MyView3D.SetProjectionType(eProjectionTypeDgPerspective)
    Call frmParent.MyKernelCAD.ShowGlobalAxes(True)
End Sub

Public Sub FitView(ByRef frmParent As Form)
    ' resets view
    Call MyView3D.Reset(False, False)
    Call frmParent.MyKernelCAD.ShowGlobalAxes(True)
    Call frmParent.MyKernelCAD.UpdateView
End Sub

Public Sub Fillet(frmParent As Form)
    Dim MyStdShape As IStdShape_DG
    Dim MyBRepFillet As IBRepFillet_DG
    Dim BoxEntity As IEntity_DG, CylinderEntity As IEntity_DG
    Dim MyBRepShape As IBRepShape_DG, MyFilletShape As IBRepShape_DG
    Dim MyBooleanEntity As IBooleanEntity_DG
    Dim dblRadius As Double
    
    On Error GoTo ErrorHandler
    
    ' create objects
    Set MyStdShape = MyObjGen3D.Create("IStdShape_DG")
    Set MyBRepFillet = MyObjGen3D.Create("IBRepFillet_DG")
    
    ' create shapes cylinders as entities, get BReps from entities for boolean operations
    Set BoxEntity = MyStdShape.Box(7, 8, 1.5)
    Set CylinderEntity = MyStdShape.Cylinder(3, 4, 10)   ' cylinder with different radii produces bad geometry
    
    ' moving box
    Call BoxEntity.GetLocation.Translate1(0, 0, 4)
    
    ' boolean operation with CylinderEntity as base
    Set MyBooleanEntity = CylinderEntity
    Call MyBooleanEntity.Unite(BoxEntity)
    
    ' get boolean sub shapes (edges)
    Dim EdgeArray As IShapeArray_DG
    Set MyBRepShape = MyBooleanEntity
    Set EdgeArray = MyBRepShape.GetSubShapes(eShTypeEdgeDG)
    dblRadius = 0.5
    
    ' most edges OK, some crash the program (or erase cylinder)
    Dim blnTest As Boolean
    blnTest = True      ' set to False for code that crashes
    
    ' trying to fillet intersection
    If (blnTest = True) Then
        ' === EXECUTES PROPERLY ===
        Call MyBRepFillet.Init(MyBRepShape, 0)
        Call MyBRepFillet.Add(dblRadius, EdgeArray.GetAt(2))    ' OK
        Call MyBRepFillet.Add(dblRadius, EdgeArray.GetAt(3))    ' OK
        Set MyFilletShape = MyBRepFillet.Build
    Else
        ' === CRASHES ===
        Call MyBRepFillet.Init(MyBRepShape, 0)
        Call MyBRepFillet.Add(dblRadius, EdgeArray.GetAt(2))    ' OK
        Call MyBRepFillet.Add(dblRadius, EdgeArray.GetAt(3))    ' OK
        Call MyBRepFillet.Add(dblRadius, EdgeArray.GetAt(1))    ' CRASH
        Call MyBRepFillet.Add(dblRadius, EdgeArray.GetAt(4))    ' CRASH
        Set MyFilletShape = MyBRepFillet.Build
    End If
    
    ' add filleted shape to model for viewing
    Call MyModel3D.AddBRepShape(MyFilletShape)
    Call MyModel3D.GetLastEntity.SetName("Solid")
    
    ' update and fit view in form
    Call FitView(frmParent)
    
    Exit Sub
    
ErrorHandler:
    ' pause program
    Debug.Assert False
End Sub
